/*  INF3105 - Structures de données et algorithmes
    UQAM | Faculté des sciences | Département d'informatique
    Lab12
    http://cria2.uqam.ca/INF3105/lab12/
*/

#include "coordonnees.h"

#include <assert.h>
#include <math.h>

constexpr int RayonTerre = 6371001;  // en mètres
constexpr double PI = 3.14159265359;

double Coordonnees::distance(const Coordonnees& coor) const {
  double s1 = sin((coor.latitude - latitude) / 2);
  double s2 = sin((coor.longitude - longitude) / 2);
  return 2 * RayonTerre * asin(sqrt(s1 * s1 + cos(latitude) * cos(coor.latitude) * s2 * s2));
}

std::istream& operator>>(std::istream& is, Coordonnees& coor) {
  char po, virgule, pf;
  is >> po;
  if (is) {
    is >> coor.latitude >> virgule >> coor.longitude >> pf;
    assert(po == '(');
    assert(virgule == ',');
    assert(pf == ')');
    coor.longitude *= PI / 180.0;
    coor.latitude *= PI / 180.0;
  }
  return is;
}

std::ostream& operator<<(std::ostream& os, const Coordonnees& coor) {
  os << "(" << (coor.latitude * 180.0 / PI) << ","
     << (coor.longitude * 180.0 / PI) << ")";
  return os;
}
